;----------------------------------------------------------------------------------
;	FILE:			PWMexplore-ISR.ASM
;
;	Description:	
;					
;
;	Version: 		1.0
;
;   Target:  		TMS320F280x / F28044
;
;	Type: 			Device dependent
;
;----------------------------------------------------------------------------------
;  Copyright Texas Instruments  2004-2006                                			
;----------------------------------------------------------------------------------
;  Revision History:
;----------------------------------------------------------------------------------
;  Date	     | Description
;----------------------------------------------------------------------------------
;  07/11/05  | Release 0.01  		Internal release. (DAF)
;----------------------------------------------------------------------------------
;  07/19/06  | Release 0.02  		Internal release. (DAF)
;----------------------------------------------------------------------------------

	; MACRO includes
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\BuckSingle_PwmDrv.asm"
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\BuckDual_PwmDrv.asm"
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\MPhIL_PwmDrv.asm"
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\FullBridgePS_PwmDrv.asm"
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\FullBridgeIBM_PwmDrv.asm"
;	.include "C:\tidcs\DPS_C280x\v101\LIB\PowerLIB\PFC2PhILHR_PwmDrv.asm"

	.include "PeripheralAddress_ASM.h"
	.include "BuckSingle_PwmDrv.asm"
	.include "BuckDual_PwmDrv.asm"
	.include "MPhIL_PwmDrv.asm"
	.include "FullBridgePS_PwmDrv.asm"
	.include "FullBridgeIBM_PwmDrv.asm"
	.include "PFC2PhILHR_PwmDrv.asm"


;==============================================================
; Incremental Build options for System check-out
;
; Note: Select only one build option
;---------------------------------------------------------------
IB00		.set	0	; Do Nothing ISR

;//===============================================================
;// Interrupt Framework options
;//---------------------------------------------------------------
;// Choose which EPWM module for Interrupt trigger
EPWM1			.set	0	; EPWM1 provides ISR trigger
EPWM2			.set	1	; EPWM2 provides ISR trigger
EPWM3			.set	0	; EPWM3 provides ISR trigger
EPWM4			.set	0	; EPWM4 provides ISR trigger
EPWM5			.set	0	; EPWM5 provides ISR trigger
EPWM6			.set	0	; EPWM6 provides ISR trigger

;**********************************************************************************
; Declare Public functions for External Reference
;**********************************************************************************
				.def 	_ISR_Init
				.def 	_ISR_Pseudo
				.def 	_ISR_Run
				.def 	_ISR_BldTbl

;**********************************************************************************
; Variable declarations
;**********************************************************************************	
; All Terminal modules initially point to the ZeroNet to ensure a known
; start state. Pad extra locations to accomodate unwanted ADC results.
ZeroNet			.usect "Net_terminals",8,1,1
DLcntr			.usect "Net_terminals",1 		; DataLog Counter
_TBcntl			.usect "Net_terminals",1 		; Time Base control sample delay
_IBnmbr			.usect "Net_terminals",1 		; IncBuild Number
Spare1			.usect "Net_terminals",1 		; filler
IBx_init_addr	.usect "IBx_addr",20,1,1		; Address array
IBx_addr		.usect "IBx_addr",20 			; Address array
_DLogBufferA 	.usect "GraphData",200,1,1		; 
_DLogBufferB 	.usect "GraphData",200			; 
_DLogBufferC 	.usect "GraphData",200			; 
_DLogBufferD 	.usect "GraphData",200			; 
				; Used by C environment
				;----------------------
				.def 	_DLogBufferA
				.def 	_DLogBufferB
				.def 	_DLogBufferC
				.def 	_DLogBufferD
				.def 	_TBcntl
				.def 	_IBnmbr


				.text
;//===============================================================
; Assembly Functions
;//===============================================================

;---------------------------
_ISR_BldTbl:
;---------------------------
; Build Address table for IBx_init

	MOVL	XAR7, #IBx_init_addr	; point to address array
	MOVL	XAR6, #IB1_init			; ADDRESS 1 <=============
	MOVL	*XAR7++, XAR6			;    Address Array <-- ACC
	MOVL	XAR6, #IB2_init			; ADDRESS 2 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB3_init			; ADDRESS 3 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB4_init			; ADDRESS 4 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB5_init			; ADDRESS 5 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB6_init			; ADDRESS 6 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB7_init			; ADDRESS 7 <=============
	MOVL	*XAR7++, XAR6			; 
	MOVL	XAR6, #IB8_init			; ADDRESS 8 <=============
	MOVL	*XAR7++, XAR6			; 

; Build Address table for IBx
	MOVL	XAR7, #IBx_addr			; point to address array
	MOVL	XAR6, #IB1				; ADDRESS 1 <=============
	MOVL	*XAR7++, XAR6			;    Address Array <-- ACC
	MOVL	XAR6, #IB2				; ADDRESS 2 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB3				; ADDRESS 3 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB4				; ADDRESS 4 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB5				; ADDRESS 5 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB6				; ADDRESS 6 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB7				; ADDRESS 7 <=============
	MOVL	*XAR7++, XAR6			;
	MOVL	XAR6, #IB8				; ADDRESS 8 <=============
	MOVL	*XAR7++, XAR6			;

	LRETR

;---------------------------
_ISR_Init:
;---------------------------
; Clear the ZeroNet
	MOVL 	XAR2,#ZeroNet
	RPT		#7 				; 8 times
	||MOV	*XAR2++, #0
	MOVW	DP, #_TBcntl
	MOV		@_TBcntl, #0	; zero Time Base delay

; Task Switch to selected IBx_init
	MOVL 	XAR2, #IBx_init_addr	; Start of Address table
	MOVW	DP, #_IBnmbr
	MOVZ	AR0, @_IBnmbr			; Index into table
	MOVL 	XAR7, *+XAR2[AR0]		; Point to (Address + IBnumber)
	LB 		*XAR7					; Branch to IB1x_init, where x=IBnumber

;---------------------------------------------------------
IB1_init:
			BuckSingle_DRV_INIT	3	; EPWM3A
			BuckSingle_DRV_INIT	4	; EPWM4A
	LB	ISR_Init_exit
;---------------------------------------------------------
IB2_init:
			BuckDual_DRV_INIT	3	; EPWM3A/3B

	LB	ISR_Init_exit
;---------------------------------------------------------
IB3_init:
			MPhIL_DRV_INIT	3, 4	; Phase1=ePWM3, Phases=4

	LB	ISR_Init_exit
;---------------------------------------------------------
IB4_init:
			FullBridgePS_DRV_INIT 3	; EPWM3A/3B/4A/4B

	LB	ISR_Init_exit
;---------------------------------------------------------
IB5_init:
			FullBridgeIBM_DRV_INIT 3 ; EPWM3A/3B/4A/4B

	LB	ISR_Init_exit
;---------------------------------------------------------
IB6_init:
			PFC2PhILHR_DRV_INIT 3	; EPWM3A/4A

	LB	ISR_Init_exit
;---------------------------------------------------------
IB7_init:
;			Other ; 

	LB	ISR_Init_exit
;---------------------------------------------------------
IB8_init:
;			Other ; 

	LB	ISR_Init_exit
;---------------------------------------------------------


ISR_Init_exit:
	LRETR


;---------------------------------------------------------
; C-callable "pseudo"  ISR - for demo purposes only
;---------------------------------------------------------
_ISR_Pseudo:

; Task Switch to selected IBx_init
	MOVL 	XAR2, #IBx_addr			; Start of Address table
	MOVW	DP, #_IBnmbr
	MOVZ	AR0, @_IBnmbr			; Index into table
	MOVL 	XAR7, *+XAR2[AR0]		; Point to (Address + IBnumber)
	LB 		*XAR7					; Branch to IB1x, where x=IBnumber

;---------------------------------------------------------
IB1:
			BuckSingle_DRV	3	; EPWM3A
			BuckSingle_DRV	4	; EPWM4A
	LB	ISR_exit
;---------------------------------------------------------
IB2:
			BuckDual_DRV	3	; EPWM3A/3B

	LB	ISR_exit
;---------------------------------------------------------
IB3:
			MPhIL_DRV	3, 4	; Phase1=ePWM3, Phases=4

	LB	ISR_exit
;---------------------------------------------------------
IB4:
			FullBridgePS_DRV 3	; EPWM3A/3B/4A/4B

	LB	ISR_exit
;---------------------------------------------------------
IB5:
			FullBridgeIBM_DRV 3 ; EPWM3A/3B/4A/4B

	LB	ISR_exit
;---------------------------------------------------------
IB6:
			PFC2PhILHR_DRV 3	; EPWM3A/4A

	LB	ISR_exit
;---------------------------------------------------------
IB7:
;			other 

	LB	ISR_exit
;---------------------------------------------------------
IB8:
;			other

	LB	ISR_exit
;---------------------------------------------------------


ISR_exit:
			LRETR



			.sect "ramfuncs"

;------------------------------------------------------------------
; ISR Run - Used here to manage the data logging for scope function
;------------------------------------------------------------------
_ISR_Run:	;CONTEXT_SAVE

			PUSH AR1H:AR0H ; 32-bit
			PUSH XAR2 ; 32-bit
			PUSH XAR3 ; 32-bit
			PUSH XAR4 ; 32-bit
		;-- Comment these to save cycles --------
			PUSH XAR5 ; 32-bit
			PUSH XAR6 ; 32-bit
			PUSH XAR7 ; 32-bit
		;----------------------------------------
			PUSH XT	  ; 32-bit

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
; Code executed every Interrupt
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;=============================
; Scope function data-logging
;=============================
	MOVL 	XAR2, 	#_DLogBufferA	; Point to buffer-A start address
	MOVL 	XAR3, 	#_DLogBufferB	; Point to buffer-B start address
	MOVL 	XAR4, 	#_DLogBufferC	; Point to buffer-C start address
	MOVL 	XAR5, 	#_DLogBufferD	; Point to buffer-D start address
	MOVW	DP, #DLcntr
	MOV		@DLcntr,#0				; reset counter

BufferFillLoop:
	MOVW	DP,		#ADCPF0R0>>6	; Use mirror registers
	MOV 	ACC,	@ADCPF0R0<<2	; Read Result0 (1st conversion)
	MOV 	*XAR2++,AL				; BufferA <-- Q15 format, Unipolar
	MOV 	ACC,	@ADCPF0R1<<2	; Read Result1 (2nd conversion)
	MOV 	*XAR3++,AL				; BufferB <-- Q15 format, Unipolar
	MOV 	ACC,	@ADCPF0R2<<2	; Read Result2 (3rd conversion)
	MOV 	*XAR4++,AL				; BufferC <-- Q15 format, Unipolar
	MOV 	ACC,	@ADCPF0R3<<2	; Read Result3 (4th conversion)
	MOV 	*XAR5++,AL				; BufferD <-- Q15 format, Unipolar

AdcEos:
	MOVW 	DP, #ADCASEQSR>>6
	MOV		AL, @ADCASEQSR			; Fetch Seq State Ptr status bits
	AND		ACC, #0x0F				; Keep 4 lower bits
	CMP		AL, #0x3				; EOS for 4 conversions
	B		AdcEos, NEQ				; Wait till End of Session
	
	; Dummy delay used to change scope timebase
	MOVW	DP, #DLcntr
	MOVZ	AR0, @_TBcntl			;loop "TBcntl" times
SampleDelayLoop:
	;NOP
	BANZ	SampleDelayLoop, AR0--

	INC 	@DLcntr
	CMP 	@DLcntr, #200			; Log 200 samples
	B		BufferFillLoop, LT		; Keep filling till buffer full					

;===================================
EXIT_ISR
;===================================
; Interrupt management before exit

	.if(EPWM1)
			MOVW 	DP,#ETCLR1>>6
			MOV 	@ETCLR1,#0x01			; Clear EPWM1 Int flag
	.endif ; EPWM1

	.if(EPWM2)
			MOVW 	DP,#ETCLR2>>6
			MOV 	@ETCLR2,#0x01			; Clear EPWM2 Int flag
	.endif ; EPWM2

	.if(EPWM3)
			MOVW 	DP,#ETCLR3>>6
			MOV 	@ETCLR3,#0x01			; Clear EPWM3 Int flag
	.endif ; EPWM3

	.if(EPWM4)
			MOVW 	DP,#ETCLR4>>6
			MOV 	@ETCLR4,#0x01			; Clear EPWM4 Int flag
	.endif ; EPWM4

	.if(EPWM5)
			MOVW 	DP,#ETCLR5>>6
			MOV 	@ETCLR5,#0x01			; Clear EPWM5 Int flag
	.endif ; EPWM5

	.if(EPWM6)
			MOVW 	DP,#ETCLR6>>6
			MOV 	@ETCLR6,#0x01			; Clear EPWM6 Int flag
	.endif ; EPWM6

			MOVW 	DP,#PIEACK>>6			; Acknowledge PIE interrupt Group 3
			MOV 	@PIEACK,#PIEACK_GROUP3

; Restore context & return
			POP XT
		;-- Comment these to save cycles ---
			POP XAR7
			POP XAR6
			POP XAR5
		;-----------------------------------
			POP XAR4
			POP XAR3
			POP XAR2
			POP AR1H:AR0H

			IRET						

